#!/bin/sh


VERSION="1.4.2"
#
# Change following variables if necessary
#
BIN_DIR=/usr/local/bin
CONF_DIR=/etc/n2rrd
#
# on linux/bash systems I assume "which" is aliased to "type -p"
# else change the variable accordingly
#
PERL=`which perl`
RRA_DIR=/var/log/n2rrd
TEMPLATES_DIR=templates
LOGFILE="$RRA_DIR/n2rrd.log"
DOCUMENT_ROOT=/var/www/html
CACHE_DIR="$DOCUMENT_ROOT/n2rrd_images_cache"
RRDTOOL=/usr/bin/rrdtool
TMPDIR=/tmp
CGIBIN=perl
NAGIOS_STATUS_FILE=`/bin/grep  '^status_file' /etc/nagios/nagios.cfg | /bin/cut -d= -f2`


#
# Normally no need to change any thing below this line
#

sed -i 	-e "s|@BIN_PERL@|$PERL -w|" \
	-e "s|@VERSION@|$VERSION|" \
	-e "s|@CONF_DIR@|$CONF_DIR|" \
	-e "s|@RRA_DIR@|$RRA_DIR|" \
	-e "s|@TEMPLATES_DIR@|$TEMPLATES_DIR|" \
	-e "s|@LOGFILE@|$LOGFILE|" \
	-e "s|@DOCUMENT_ROOT@|$DOCUMENT_ROOT|" \
	-e "s|@CACHE_DIR@|$CACHE_DIR|" \
	-e "s|@RRDTOOL@|$RRDTOOL|" \
	-e "s|@TMPDIR@|$TMPDIR|" \
	-e "s|@CGIBIN@|$CGIBIN|" \
	-e "s|@NAGIOS_STATUS_FILE@|$NAGIOS_STATUS_FILE|" n2rrd.pl rrd2graph.cgi dist-n2rrd.conf


install -v -d $CONF_DIR
install -v -d $CONF_DIR/js
install -v -d $BIN_DIR
install -v -m 644 dist-n2rrd.conf $CONF_DIR/dist-n2rrd.conf

cp -r templates $CONF_DIR
cp -r js $CONF_DIR


install -v -m 755 n2rrd.pl $BIN_DIR

echo "
=========================================================

1) Edit rrd2graph.cgi and change following variable
   1.1)	\$conf_file 
	to appropriate value
   1.2) uncommnet line \"undef \$conf_file\" in case you are using
        just the defaults

2) Copy rrd2graph to your cgi-bin directory

3) Read further installation guide at n2rrd.diglinks.com
=========================================================
"

exit 0
