Name:          	nagios-n2rrd
Version:       	1.4.2
Release:       	1
License:       	GPLv2
Group:         	Application/System
Source:		http://n2rrd.diglinks.com/download/n2rrd-%{version}.tar.gz
BuildRoot:    	/var/tmp/n2rrd-%{version}
Summary:       	N2RRD/RRD2GRAPH Performance data collector and Graph generator
Packager:      	Badri Pillai <badri@diglinks.com>
BuildArch:     	noarch
BuildRequires: sed >= 4.0
Requires:      	nagios >= 3  
Requires:      	httpd  
Requires:      	perl >= 5
Requires: 	rrdtool > 1.3

# OS specfic macros
# default
%define __cut /bin/cut
%define	web_server_user apache
%define web_server_group apache

%if %{_vendor} == "redhat"
	%define __cut /usr/bin/cut
	%define	web_server_user apache
	%define web_server_group apache
Requires: perl-rrdtool
%endif

%if %{_vendor} == "suse"
	%define __cut /usr/bin/cut
	%define	web_server_user wwwrun
	%define web_server_group www
%endif


#nagios related
%define         nagios_conf_dir   /etc/nagios
%define		nagios_user %(%{__grep} '^nagios_user' %{nagios_conf_dir}/nagios.cfg | %{__cut} -d= -f2)
%define		nagios_group %(%{__grep} '^nagios_group' %{nagios_conf_dir}/nagios.cfg | %{__cut} -d= -f2)
%define         nagios_data_dir   /usr/share/nagios
%define         nagios_lib_dir    /usr/lib/nagios
%define         nagios_cgi_dir    %{nagios_lib_dir}/cgi
%define 	nagios_log_dir    /var/log/nagios
%define		nagios_status_file %(%{__grep} '^status_file' %{nagios_conf_dir}/nagios.cfg | %{__cut} -d= -f2)

# n2rrd related
%define         n2rrd_conf_dir    %{_sysconfdir}/n2rrd
# subdir to n2rrd_conf_dir
%define		n2rrd_templates_dir	templates
%define         n2rrd_bin_dir	%{_bindir}
%define		n2rrd_rra_dir	/var/log/n2rrd
%define		n2rrd_log_file	%{n2rrd_rra_dir}/n2rrd.log
%define		rrd2graph_cgi_root_dir /var/www
%define		rrd2graph_doc_root /var/www/html
# subdur to rrd2graph_doc_root
%define		rrd2graph_cache_dir n2rrd_images_cache
# subdir, defined such so that the variable could be used for configration
%define		rrd2graph_cgi_dir perl
# This variable, does not affect the graph generation, instead used while printing/displaying the
# graph source, such that one can cut and paste the graph generation source for testing
%define		rrdtool		/usr/bin/rrdtool


%description
Nagios to RRD = n2rrd, is a small perl script, which analyzes perf-data string for one or more name=value pairs and creates/updates RRA (Round Robin Archives).

The archive can later be viewed by any RRD database graph frontend e.g. rrd2graph, Cacti, Drraw, etc. 

Example plugin output string and what n2rrd extracts 

    * check_http output (anything after '|'): time=0.294561s;;;0. size=46869B;;;0
    * n2rrd extracts: time=0. size=46869
    * atleast one pair like 'name=value' must exist. 

Features 

    * template based RRA creation
    * possibility to parse non standard performance data string with external perl script
      and pass n2rrd conform string to n2rrd
    * possibility to relocate rra file
    * possibility to rewrite DS names
    * mapping service name string to single word value
      e.g. System load average to load
    * n2rrd.pl works with SpeedyCGI 

%package rrd2graph
Summary: rrd2graph display tool for rrd data generated by n2rrd
Group: Application/System
Requires: perl >= 5
Requires: rrdtool > 1.3


%description rrd2graph
rrd2graph is CGI tool to display RRD data as graphs, written in perl

Features

    * for displaying rrd data generated by n2rrd
    * template based GRAPH creation
    * zoom in/out of graphs
    * searching/grouping of graphs
    * if more than one DS values stored, individual values can be viewed by rrd2graph.cgi
    * mod_perl support

%prep
%setup -n n2rrd-%{version}


%{__mkdir} -p ${RPM_BUILD_ROOT}%{nagios_conf_dir}

%{__cat} > ${RPM_BUILD_ROOT}%{nagios_conf_dir}/n2rrd.cfg <<EOF_N2RRD_CFG
#
# if RRA files are placed under CACHE_DIR/HOSTGROUPNAME
# then uncomment the following command name and comment the following command
#define command{
#        command_name    n2rrd-process-host-perfdata
#        command_line    %{n2rrd_bin_dir}/n2rrd.pl -c "%{n2rrd_conf_dir}/n2rrd.conf" -G '\$HOSTGROUPNAME$' -D "HOST" -N "%{nagios_status_file}" -C '\$HOSTCHECKCOMMAND$' -T \$LASTHOSTCHECK$ -H \$HOSTNAME$ -s "check_fping" -o "\$HOSTPERFDATA$"
#}
define command{
        command_name    n2rrd-process-host-perfdata
        command_line    %{n2rrd_bin_dir}/n2rrd.pl -c "%{n2rrd_conf_dir}/n2rrd.conf" -D "HOST" -N "%{nagios_status_file}" -C '\$HOSTCHECKCOMMAND$' -T \$LASTHOSTCHECK$ -H \$HOSTNAME$ -s "check_fping" -o "\$HOSTPERFDATA$"
}

# if RRA files are placed under CACHE_DIR/HOSTGROUPNAME
# then uncomment the following command name and comment the following command
#define command{
#    command_name    n2rrd-process-service-perfdata
#    command_line    %{n2rrd_bin_dir}/n2rrd.pl -c "%{n2rrd_conf_dir}/n2rrd.conf" -G '\$HOSTGROUPNAME$' -N "%{nagios_status_file}" -C '\$SERVICECHECKCOMMAND$' -e \$SERVICEEXECUTIONTIME$ -l \$SERVICELATENCY$ -T \$LASTSERVICECHECK$ -H \$HOSTNAME$ -s "\$SERVICEDESC$" -o "\$SERVICEPERFDATA$"
#    }
define command{
    command_name    n2rrd-process-service-perfdata
    command_line    %{n2rrd_bin_dir}/n2rrd.pl -c "%{n2rrd_conf_dir}/n2rrd.conf" -N "%{nagios_status_file}" -C '\$SERVICECHECKCOMMAND$' -e \$SERVICEEXECUTIONTIME$ -l \$SERVICELATENCY$ -T \$LASTSERVICECHECK$ -H \$HOSTNAME$ -s "\$SERVICEDESC$" -o "\$SERVICEPERFDATA$"
    }
EOF_N2RRD_CFG


%{__mkdir} -p ${RPM_BUILD_ROOT}%{n2rrd_bin_dir}
%{__mkdir} -p ${RPM_BUILD_ROOT}%{n2rrd_conf_dir}/js
%{__mkdir} -p ${RPM_BUILD_ROOT}%{rrd2graph_cgi_root_dir}/%{rrd2graph_cgi_dir}

%{__cp} -r templates ${RPM_BUILD_ROOT}%{n2rrd_conf_dir}
%{__cp} js/zoom.js   ${RPM_BUILD_ROOT}%{n2rrd_conf_dir}/js

%{__sed} -i 	-e 's|@BIN_PERL@|%{__perl} -w|' \
		-e "s|@VERSION@|%{version}|" \
		-e "s|@CONF_DIR@|%{n2rrd_conf_dir}|" \
		-e "s|@RRA_DIR@|%{n2rrd_rra_dir}|" \
		-e "s|@TEMPLATES_DIR@|%{n2rrd_templates_dir}|" \
		-e "s|@SERVICE_NAME_MAPS@|%{n2rrd_templates_dir}/maps/service_name_maps|" \
		-e "s|@LOGFILE@|%{n2rrd_log_file}|" \
		-e "s|@DOCUMENT_ROOT@|%{rrd2graph_doc_root}|" \
		-e "s|@CACHE_DIR@|%{rrd2graph_cache_dir}|" \
		-e "s|@TMPDIR@|/tmp|" \
		-e "s|@RRDTOOL@|%{rrdtool}|" \
		-e "s|@CGIBIN@|%{rrd2graph_cgi_dir}|" \
		-e "s|@NAGIOS_STATUS_FILE@|%{nagios_status_file}|" n2rrd.pl rrd2graph.cgi dist-n2rrd.conf

%{__install} -v -m 644 dist-n2rrd.conf ${RPM_BUILD_ROOT}%{n2rrd_conf_dir}/n2rrd.conf
%{__install} -o %{nagios_user} -g %{nagios_group} -m 750 n2rrd.pl  ${RPM_BUILD_ROOT}%{n2rrd_bin_dir}/
%{__install} -o %{web_server_user} -g %{web_server_group} -m 755 rrd2graph.cgi ${RPM_BUILD_ROOT}%{rrd2graph_cgi_root_dir}/%{rrd2graph_cgi_dir}/

%post

%{__sed} -i -e 's/^\(host_perfdata_command=\).*/\1n2rrd-process-host-perfdata/' \
          -e 's/^\(process_performance_data=\).*/\11/' \
          -e 's/^\(service_perfdata_command=\).*/\1n2rrd-process-service-perfdata/' \
			%{nagios_conf_dir}/nagios.cfg

echo '
=========================================================

1) rrd2graph.cgi is placed under %{rrd2graph_cgi_root_dir}/%{rrd2graph_cgi_dir}/
   you may like to move it to some other place
2) Edit rrd2graph.cgi and change following variable
   2.1) $conf_file
        to appropriate value
   2.2) commnet line "undef $conf_file" in case you are using
        some configuration varibales to overide default values

3) Read further installation guide at n2rrd.diglinks.com
=======================================================
'

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -fr $RPM_BUILD_ROOT

%files
%defattr(-,%{nagios_user},%{nagios_group})
%config(noreplace) %{nagios_conf_dir}/n2rrd.cfg
%{n2rrd_conf_dir}/n2rrd.conf
%{n2rrd_bin_dir}/n2rrd.pl
%config(noreplace) %{n2rrd_conf_dir}/n2rrd.conf
%{n2rrd_conf_dir}/%{n2rrd_templates_dir}/*.t
%{n2rrd_conf_dir}/%{n2rrd_templates_dir}/maps/*
%{n2rrd_conf_dir}/%{n2rrd_templates_dir}/code/*
%{n2rrd_conf_dir}/%{n2rrd_templates_dir}/rra/*
%{n2rrd_conf_dir}/%{n2rrd_templates_dir}/rewrite/*
%{n2rrd_conf_dir}/%{n2rrd_templates_dir}/nagvis/*

%files rrd2graph
%defattr(644,%{web_server_user},%{nagios_group})
%attr(755,%{web_server_user},%{nagios_group}) %{rrd2graph_cgi_root_dir}/%{rrd2graph_cgi_dir}/*
%{n2rrd_conf_dir}/js/zoom.js
%{n2rrd_conf_dir}/%{n2rrd_templates_dir}/graph/*

%changelog
