$PREDICTION$
--lazy
--step=500
--title="$HOSTNAME$:$SERVICENAME$"
--base=1024
-E
--color="BACK#E8E8F0"
-l 0
-u 100
-r
-v "Percent Utilization"
--height=200
--width=500

#--font="TITLE:10:"
#
# The filesystem dataset
#
DEF:f=$RRD_FILENAME$:free:AVERAGE:step=500
DEF:a=$RRD_FILENAME$:used:AVERAGE:step=500
DEF:b=$RRD_FILENAME$:used:AVERAGE:step=500:start=-3d
DEF:g=$RRD_FILENAME$:free:AVERAGE:step=500:start=-3d
DEF:c=$RRD_FILENAME$:used:AVERAGE:step=500:start=-1w
DEF:h=$RRD_FILENAME$:free:AVERAGE:step=500:start=-1w
DEF:d=$RRD_FILENAME$:used:AVERAGE:step=500:start=-1m
DEF:i=$RRD_FILENAME$:free:AVERAGE:step=500:start=-1m

CDEF:a_total=a,f,+
CDEF:fsu_a=a,a_total,/,100,*
CDEF:used=a,1024,*
CDEF:free=a_total,a,-,1024,*

CDEF:b_total=b,g,+
CDEF:fsu_b=b,b_total,/,100,*

CDEF:c_total=c,h,+
CDEF:fsu_c=c,c_total,/,100,*

CDEF:d_total=d,i,+
CDEF:fsu_d=d,d_total,/,100,*

#
# Calculate our Least Squares Line (LSL) values based in the fsu data.
#
VDEF:slope_a=fsu_a,LSLSLOPE
VDEF:yint_a=fsu_a,LSLINT
VDEF:correl_a=fsu_a,LSLCORREL
#
VDEF:slope_b=fsu_b,LSLSLOPE
VDEF:yint_b=fsu_b,LSLINT
VDEF:correl_b=fsu_b,LSLCORREL
#
VDEF:slope_c=fsu_c,LSLSLOPE
VDEF:yint_c=fsu_c,LSLINT
VDEF:correl_c=fsu_c,LSLCORREL
#
VDEF:slope_d=fsu_d,LSLSLOPE
VDEF:yint_d=fsu_d,LSLINT
VDEF:correl_d=fsu_d,LSLCORREL
#
# Generate the slope line projection data set.
#
CDEF:projuse_a=fsu_a,POP,yint_a,slope_a,COUNT,*,+
CDEF:fyline_a=projuse_a,0,100,LIMIT
#
CDEF:projuse_b=fsu_b,POP,yint_b,slope_b,COUNT,*,+
CDEF:fyline_b=projuse_b,0,100,LIMIT
#
CDEF:projuse_c=fsu_c,POP,yint_c,slope_c,COUNT,*,+
CDEF:fyline_c=projuse_c,0,100,LIMIT
#
CDEF:projuse_d=fsu_d,POP,yint_d,slope_d,COUNT,*,+
CDEF:fyline_d=projuse_d,0,100,LIMIT
#
# Get the last value off of the projected data set.
#
VDEF:firstv=fsu_a,FIRST
VDEF:lastv=projuse_a,LAST
#
# Mark the 100% crossover time (anything over 99.99%).
# (walk a trend data set, if slope is positive and the value is
#  > 99.99, then set value to infinity, otherwise set to unknown).
#
CDEF:crosslimit_a=projuse_a,99.99,INF,LIMIT,UN,UNKN,slope_a,0,LT,UNKN,TIME,IF,IF
CDEF:crosslimit_b=projuse_b,99.99,INF,LIMIT,UN,UNKN,slope_b,0,LT,UNKN,TIME,IF,IF
CDEF:crosslimit_c=projuse_c,99.99,INF,LIMIT,UN,UNKN,slope_c,0,LT,UNKN,TIME,IF,IF
CDEF:crosslimit_d=projuse_d,99.99,INF,LIMIT,UN,UNKN,slope_d,0,LT,UNKN,TIME,IF,IF
#
# Pull the first known value from the crosslimit data sets defined
# above. This will be the first value that hit the 100% mark.
# Use the :strftime argument to gprint to print the timestamp of
# this value later.
#
VDEF:co_limit_a=crosslimit_a,FIRST
VDEF:co_limit_b=crosslimit_b,FIRST
VDEF:co_limit_c=crosslimit_c,FIRST
VDEF:co_limit_d=crosslimit_d,FIRST
#
GPRINT:firstv:"Period between %d/%b/%Y "\g:strftime
GPRINT:lastv:" and %d/%b/%Y\c":strftime
COMMENT:\s

#
# Draw the base area using our base color (slight transparent yellow).
#
#AREA:fsu_a#FFCC66
AREA:fsu_a#FF0000:"Used\: "
GPRINT:used:LAST:"%.2lf %s"
GPRINT:fsu_a:LAST:"(%.0lf%%)"
CDEF:p_free=100,fsu_a,-
GPRINT:free:LAST:"Free\: %.2lf %s"
GPRINT:p_free:LAST:"(%.0lf%%)\n"
AREA:p_free#0caf07::STACK
#
CDEF:g_used_cl2=fsu_a,0.98,*
AREA:g_used_cl2#FF0000
CDEF:g_used_cl10=fsu_a,0.90,*
AREA:g_used_cl10#FF0000
CDEF:g_used_cl15=fsu_a,0.85,*
AREA:g_used_cl15#F20000
CDEF:g_used_cl20=fsu_a,0.80,*
AREA:g_used_cl20#E50000
CDEF:g_used_cl25=fsu_a,0.75,*
AREA:g_used_cl25#D90000
CDEF:g_used_cl30=fsu_a,0.70,*
AREA:g_used_cl30#CC0000
CDEF:g_used_cl35=fsu_a,0.65,*
AREA:g_used_cl35#BF0000
CDEF:g_used_cl40=fsu_a,0.60,*
AREA:g_used_cl40#B20000
CDEF:g_used_cl45=fsu_a,0.55,*
AREA:g_used_cl45#A60000
CDEF:g_used_cl50=fsu_a,0.50,*
AREA:g_used_cl50#990000
CDEF:g_used_cl55=fsu_a,0.45,*
AREA:g_used_cl55#8C0000
CDEF:g_used_cl60=fsu_a,0.40,*
AREA:g_used_cl60#7F0000
CDEF:g_used_cl65=fsu_a,0.35,*
AREA:g_used_cl65#730000
CDEF:g_used_cl70=fsu_a,0.30,*
AREA:g_used_cl70#660000
CDEF:g_used_cl75=fsu_a,0.25,*
AREA:g_used_cl75#590000
CDEF:g_used_cl80=fsu_a,0.20,*
AREA:g_used_cl80#4C0000
CDEF:g_used_cl85=fsu_a,0.15,*
AREA:g_used_cl85#400000


#
# Top it all off with a darker line for contrast.
#
LINE:fsu_a#116611
#
# Now our ledgends and other info
#
COMMENT:"Projection\t\t\t"
COMMENT:"Co-Variance\t"
COMMENT:"100% Crossing"\l
#
COMMENT:"--------------------\t"
COMMENT:"-----------\t"
COMMENT:"-------------"\l 
#
LINE2:fyline_a#CD12CD:"From graph start\t"
GPRINT:correl_a:"%6.2lf\t"
GPRINT:co_limit_a:" %d/%b/%Y":strftime
COMMENT:" "\l
#
LINE2:fyline_b#C0C0FF:"From 3 days ago \t"
GPRINT:correl_b:"%6.2lf\t"
GPRINT:co_limit_b:" %d/%b/%Y":strftime
COMMENT:" "\l
#
LINE2:fyline_c#FFFF00:"From 1 week ago \t"
GPRINT:correl_c:"%6.2lf\t"
GPRINT:co_limit_c:" %d/%b/%Y":strftime
COMMENT:" "\l
#
LINE2:fyline_d#FF8000:"From 1 month ago\t"
GPRINT:correl_d:"%6.2lf\t"
GPRINT:co_limit_d:" %d/%b/%Y":strftime
COMMENT:" "\l
